<?php
/** Start the engine */
require_once( get_template_directory() . '/lib/init.php' );

/** Child Theme Stuff (do not remove)*/
require_once( CHILD_DIR . '/lib/admin/greg-theme-settings.php' );
define( 'CHILD_THEME_NAME', 'Greg' );

/** Add Viewport meta tag for mobile browsers */
add_action( 'genesis_meta', 'add_viewport_meta_tag' );
function add_viewport_meta_tag() {
    echo '<meta name="viewport" content="width=device-width, initial-scale=1.0"/>';
}
/** Custom image sizes */
add_image_size( 'smallthumb', 75, 75, TRUE );
//** Script Managment **//
add_action( 'wp_enqueue_scripts', 'load_my_scripts' );
function load_my_scripts() {
	  wp_deregister_script( 'jquery' );
	  wp_deregister_script( 'jquery-ui' );
	  wp_register_script( 'jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js' );
	  wp_register_script( 'jquery-ui', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.16/jquery-ui.min.js' );
	  wp_register_script( 'jquery-easing', CHILD_URL . '/js/jquery.easing-1.3.pack.js' );
	  wp_register_script( 'FancyBox', CHILD_URL . '/js/jquery.fancybox-1.3.4.pack.js' );
	  wp_register_script( 'theme-js', CHILD_URL . '/js/theme-js.js');
	  wp_enqueue_script( 'jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js', array( 'jquery' ), '4.0', false );
	  wp_enqueue_script( 'jquery-ui', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.16/jquery-ui.min.js', array( 'jquery' ), '1.8.16' );
	  wp_enqueue_script( array( 'FancyBox', 'jquery-easing', 'theme-js' ),'', false );
}
/** Add support for custom background */
add_custom_background();

/** Add support for custom header */
add_theme_support( 'genesis-custom-header', array( 'width' => 960, 'height' => 100 ) );

/** Add support for 3-column footer widgets */
add_theme_support( 'genesis-footer-widgets', 3 );

/** Move secondary nav menu */
remove_action( 'genesis_after_header', 'genesis_do_nav' );
add_action( 'genesis_before_header', 'genesis_do_nav' );

/** Remove the post meta function */
remove_action( 'genesis_after_post_content', 'genesis_post_meta' );

/** Remove the post info function */
remove_action( 'genesis_before_post_content', 'genesis_post_info' );

/** Custom Footer with Navigation */

add_filter( 'genesis_footer_output', 'footer_output_filter', 10, 3 );

function footer_output_filter( $output, $backtotop_text, $creds_text, $creds_nav ) {
   $backtotop_text = '[footer_backtotop text="Top of Page"]';
   $creds_nav = '<a href="'. trailingslashit( get_bloginfo('url') ) .'" title="'. esc_attr( get_bloginfo('name') ) .' rel="nofollow"">&copy; 2012' . get_bloginfo('name').'</a>';
   $output = '<div class="alignright">' . $backtotop_text . '</div>' . '<div>' . $creds_nav. '</div>';
    return $output;
}